VERSION 5.00
Begin VB.Form frmCog 
   ClientHeight    =   3225
   ClientLeft      =   3450
   ClientTop       =   3120
   ClientWidth     =   4680
   Icon            =   "frmCog.frx":0000
   LinkTopic       =   "frmCog"
   MDIChild        =   -1  'True
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   3225
   ScaleWidth      =   4680
   Begin VB.TextBox txtMain 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      HideSelection   =   0   'False
      Left            =   0
      MultiLine       =   -1  'True
      OLEDragMode     =   1  'Automatic
      OLEDropMode     =   1  'Manual
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   210
   End
End
Attribute VB_Name = "frmCog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim LocalFile As String
Dim Original As Boolean
Dim Modified As Boolean

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const EM_LINEFROMCHAR = &HC9
Private Const EM_LINEINDEX = &HBB

Public Function SetLocalFile(File As String)
LocalFile = File
End Function

Public Function SetOriginal()
Original = True
Modified = False
End Function

Public Function SetModified()
Modified = False
End Function

Public Function TrimTag()
Dim temp As String
Dim trim As String
trim = GetString("Trim")
If trim = "" Then
trim = 20
End If
temp = LocalFile
If Len(temp) > CInt(trim) Then
temp = "..." & Right(temp, (CInt(trim) - 3))
Me.Tag = temp
End If
End Function

Private Sub Form_Load()
Original = False
Modified = False
TrimTag
Hook txtMain.hWnd
If GetString("FontS") <> "" Then SetFont GetString("Font"), GetString("FontSize"), GetString("FontBold"), GetString("FontItalics")
If GetString("ColorS") <> "" Then SetColor GetString("CogColor")
If GetString("FontColorS") <> "" Then SetFontColor GetString("FontColor")
End Sub

Public Function Line_Check()
Dim nLine
nLine = SendMessage(txtMain.hWnd, EM_LINEFROMCHAR, -1, 0)
Dim temp As String
Dim trim As String
trim = GetString("Trim")
If trim = "" Then
trim = 20
End If
temp = LocalFile
If Len(temp) > CInt(trim) Then
temp = "..." & Right(temp, (CInt(trim) - 3))
Me.Tag = temp
End If

If Modified = False Then
Me.Caption = Me.Tag & " - " & (Str(nLine) + 1)
Else
Me.Caption = Me.Tag & " [modified]" & " - " & (Str(nLine) + 1)
End If
End Function

'Private Sub txtMain_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'If Button = vbRightButton Then PopupMenu mnuPopup
'End Sub

Private Sub txtMain_OLECompleteDrag(Effect As Long)
txtMain.OLEDropMode = 1
mdiMain.DaDReset
End Sub

Private Sub txtMain_OLEDragOver(data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
On Error GoTo err
Dim fname As Variant
For Each fname In data.files
Next fname
Exit Sub
err:
txtMain.OLEDropMode = 2
Exit Sub
End Sub

Private Sub Form_OLEDragDrop(data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
mdiMain.DaD data
End Sub

Private Sub Form_Resize()
On Error Resume Next
txtMain.Height = Me.Height - 350
txtMain.Width = Me.Width - 100
End Sub

Private Sub Form_Unload(cancel As Integer)
If mdiMain.mnuHelpCaution.Checked = True Then
If Modified = True Then
Dim cancell As Integer
SetStatus "Cog not saved!"
cancell = MsgBox("Save changes?", vbExclamation + vbYesNoCancel, "Cog not saved!")
Select Case cancell
Case Is = 6
save:
If Original = False Then
mdiMain.FlatSaveFile ""
Else
mdiMain.SaveFile LocalFile, Me
End If
If Original = False Then
SetStatus "Cog Preserved."
cancel = 1
Exit Sub
End If
cancel = 0
mdiMain.UpdateChildren True
UnHook
Case Is = 7
cancel = 0
mdiMain.UpdateChildren True
UnHook
Case Is = 2
SetStatus "Cog preserved."
cancel = 1
End Select
Else
mdiMain.UpdateChildren True
UnHook
End If
Else
mdiMain.UpdateChildren True
UnHook
End If
End Sub

Public Function Revert()
If Original = False Then
SetStatus "Cannot revert;  cog never saved."
Exit Function
End If

If Modified = False Then
SetStatus "Cannot revert;  cog never changed."
Exit Function
End If

Dim cancel As Integer
cancel = MsgBox("Revert to saved?", vbExclamation + vbOKCancel, "Revert?")
If cancel = 2 Then Exit Function

Dim intfile As Integer
intfile = FreeFile
Open LocalFile For Input As #intfile
txtMain.text = Input$(LOF(intfile), intfile)
Close #intfile

Modified = False
End Function


Public Function ExternalSaveAs()

If Original = True Then
mdiMain.FlatSaveFile LocalFile
Else
mdiMain.FlatSaveFile ""
End If
End Function

Public Function ExternalSave()

If Original = False Then
mdiMain.FlatSaveFile ""
'SetOriginal
Else
mdiMain.SaveFile LocalFile, Me
SetOriginal
End If

End Function

Private Sub txtMain_Change()
Line_Check
Modified = True
If mdiMain.mnuSBPopupClear.Checked = True Then mdiMain.statusbar.SimpleText = ""
End Sub

Private Sub txtMain_Click()
Line_Check
End Sub

Private Sub txtMain_KeyDown(KeyCode As Integer, Shift As Integer)
Line_Check
End Sub

Private Sub txtMain_KeyPress(KeyAscii As Integer)
Line_Check
End Sub

Private Sub txtMain_KeyUp(KeyCode As Integer, Shift As Integer)
Line_Check
End Sub

Private Sub txtMain_OLEDragDrop(data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
mdiMain.DaD data
End Sub

Public Function SetColor(Color As Long)
If Color = 0 Then Exit Function
Me.txtMain.BackColor = Color
End Function

Public Function SetFont(Font As String, Size As Integer, Bold As Boolean, Italics As Boolean)
If Font = " " Then Exit Function
txtMain.FontName = Font
txtMain.FontSize = Size
txtMain.FontBold = Bold
txtMain.FontItalic = Italics
End Function

Public Function SetFontColor(Color As Long)
txtMain.ForeColor = Color
End Function
