VERSION 5.00
Begin VB.Form frmHex 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Hex calculator"
   ClientHeight    =   4710
   ClientLeft      =   45
   ClientTop       =   300
   ClientWidth     =   3510
   Icon            =   "frmHex.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4710
   ScaleWidth      =   3510
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frameHexDec 
      Caption         =   "Convert Hex to Dec"
      Height          =   735
      Left            =   0
      TabIndex        =   19
      Top             =   480
      Width           =   3495
      Begin VB.TextBox txtHexDec 
         Height          =   405
         Left            =   120
         OLEDragMode     =   1  'Automatic
         OLEDropMode     =   2  'Automatic
         TabIndex        =   0
         ToolTipText     =   "Input a hex value to convert to dec.  The '0x' can be used, but is not needed."
         Top             =   240
         Width           =   1815
      End
      Begin VB.CommandButton cmdHexDec 
         Caption         =   "Convert!"
         Height          =   375
         Left            =   2040
         TabIndex        =   1
         ToolTipText     =   "Converts the inputted hex value into decimal."
         Top             =   240
         Width           =   1335
      End
   End
   Begin VB.TextBox txtResult 
      Height          =   375
      Left            =   600
      OLEDragMode     =   1  'Automatic
      OLEDropMode     =   2  'Automatic
      TabIndex        =   12
      ToolTipText     =   "This is the result from the conversion/math."
      Top             =   0
      Width           =   1575
   End
   Begin VB.Frame frameDecHex 
      Caption         =   "Convert Dec to Hex"
      Height          =   735
      Left            =   0
      TabIndex        =   18
      Top             =   1320
      Width           =   3495
      Begin VB.TextBox txtDecHex 
         Height          =   375
         Left            =   120
         OLEDragMode     =   1  'Automatic
         OLEDropMode     =   2  'Automatic
         TabIndex        =   2
         ToolTipText     =   "Input a dec value to convert to hex."
         Top             =   240
         Width           =   1815
      End
      Begin VB.CommandButton cmdDecHex 
         Caption         =   "Convert!"
         Height          =   375
         Left            =   2040
         TabIndex        =   3
         ToolTipText     =   "Converts the inputted dec value into hex."
         Top             =   240
         Width           =   1335
      End
   End
   Begin VB.Frame frameMaths 
      Caption         =   "Add/subtract Hex values"
      Height          =   1935
      Left            =   0
      TabIndex        =   14
      Top             =   2160
      Width           =   3495
      Begin VB.TextBox txtHexOne 
         Height          =   375
         Left            =   1560
         OLEDragMode     =   1  'Automatic
         OLEDropMode     =   2  'Automatic
         TabIndex        =   4
         ToolTipText     =   "Input a hex value to add/subtract."
         Top             =   240
         Width           =   1815
      End
      Begin VB.TextBox txtHexTwo 
         Height          =   375
         Left            =   1560
         OLEDragMode     =   1  'Automatic
         OLEDropMode     =   2  'Automatic
         TabIndex        =   5
         ToolTipText     =   "Enter another hex value to be added to/subtracted from the first."
         Top             =   720
         Width           =   1815
      End
      Begin VB.CommandButton cmdHexSub 
         Caption         =   "Subtract"
         Height          =   495
         Left            =   2400
         TabIndex        =   7
         ToolTipText     =   "Subtracts the second value from the first."
         Top             =   1200
         Width           =   975
      End
      Begin VB.CommandButton cmdHexAdd 
         Caption         =   "Add"
         Height          =   495
         Left            =   1320
         TabIndex        =   6
         ToolTipText     =   "Adds the inputted hex values."
         Top             =   1200
         Width           =   975
      End
      Begin VB.OptionButton radHex 
         Caption         =   "Hex"
         Height          =   195
         Left            =   120
         TabIndex        =   8
         ToolTipText     =   "Ouput will be in hex."
         Top             =   1320
         Value           =   -1  'True
         Width           =   855
      End
      Begin VB.OptionButton radDec 
         Caption         =   "Dec"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         ToolTipText     =   "Output will be in dec."
         Top             =   1560
         Width           =   855
      End
      Begin VB.Label lblHexOne 
         Caption         =   "First value:"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   360
         Width           =   975
      End
      Begin VB.Label lblHexTwo 
         Caption         =   "Second value:"
         Height          =   255
         Left            =   120
         TabIndex        =   16
         Top             =   720
         Width           =   1095
      End
      Begin VB.Label lblOutput 
         Caption         =   "Output:"
         Height          =   255
         Left            =   120
         TabIndex        =   15
         Top             =   1080
         Width           =   615
      End
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "Copy"
      Default         =   -1  'True
      Height          =   375
      Left            =   2280
      TabIndex        =   13
      ToolTipText     =   "Copies the result to the clipboard."
      Top             =   0
      Width           =   1215
   End
   Begin VB.CommandButton cmdSelector 
      Caption         =   "Load teh SelectOr"
      Height          =   495
      Left            =   120
      TabIndex        =   10
      ToolTipText     =   "Loads the flag picker."
      Top             =   4200
      Width           =   1815
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   495
      Left            =   2040
      TabIndex        =   11
      ToolTipText     =   "Close this window."
      Top             =   4200
      Width           =   1455
   End
   Begin VB.Label lblResult 
      Caption         =   "Result:"
      Height          =   255
      Left            =   0
      TabIndex        =   20
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "frmHex"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdClose_Click()
frmHex.Hide
End Sub

Private Sub cmdCopy_Click()
Clipboard.SetText (txtResult.text)
SetStatus "Copied " & txtResult.text
End Sub

Private Sub cmdDecHex_Click()
On Error GoTo err
Printhex "0x" & hex(txtDecHex.text)
Exit Sub
err:
Printhex "Error."
Exit Sub
End Sub

Private Sub cmdHexAdd_Click()
On Error GoTo err
Dim lngResult As Long
Dim lngFirst As Long
Dim lngSecond As Long
Dim strOne As String
Dim strTwo As String
Dim strFilter As String
strOne = txtHexOne.text
strFilter = Left(strOne, (Len(strOne) - Len(strOne) + 2))
If (StrConv(strFilter, vbLowerCase)) = "0x" Then
strOne = Right(strOne, (Len(strOne) - 2))
End If
strTwo = txtHexTwo.text
strFilter = Left(strTwo, (Len(strTwo) - Len(strTwo) + 2))
If (StrConv(strFilter, vbLowerCase)) = "0x" Then
strTwo = Right(strTwo, (Len(strTwo) - 2))
End If
lngFirst = CLng("&H" & strOne)
lngSecond = CLng("&H" & strTwo)
lngResult = lngFirst + lngSecond
If radHex.value = True Then
Printhex "0x" & hex(lngResult)
Else
Printhex Str(lngResult)
End If
Exit Sub
err:
Printhex "Error."
Exit Sub
End Sub

Private Sub cmdHexDec_Click()
On Error GoTo err
Dim strHex As String
Dim strFilter As String
strHex = txtHexDec.text
strFilter = Left(strHex, (Len(strHex) - Len(strHex) + 2))
If (StrConv(strFilter, vbLowerCase)) = "0x" Then
strHex = Right(strHex, (Len(strHex) - 2))
End If
PrintDec (strHex)
Exit Sub
err:
Printhex "Error."
Exit Sub
End Sub

Private Sub cmdHexSub_Click()
On Error GoTo err
Dim lngResult As Long
Dim lngFirst As Long
Dim lngSecond As Long
Dim strOne As String
Dim strTwo As String
Dim strFilter As String
strOne = txtHexOne.text
strFilter = Left(strOne, (Len(strOne) - Len(strOne) + 2))
If (StrConv(strFilter, vbLowerCase)) = "0x" Then
strOne = Right(strOne, (Len(strOne) - 2))
End If
strTwo = txtHexTwo.text
strFilter = Left(strTwo, (Len(strTwo) - Len(strTwo) + 2))
If (StrConv(strFilter, vbLowerCase)) = "0x" Then
strTwo = Right(strTwo, (Len(strTwo) - 2))
End If
lngFirst = CLng("&H" & strOne)
lngSecond = CLng("&H" & strTwo)
lngResult = lngFirst - lngSecond
If radHex.value = True Then
Printhex "0x" & hex(lngResult)
Else
Printhex Str(lngResult)
End If
Exit Sub
err:
Printhex "Error."
Exit Sub
End Sub

Private Sub cmdSelector_Click()
Dim i As Boolean
If GetString("ViewStyle") = "MDI" Then
If mdiMain.mnuHelpOnTop.Checked = True Then
mdiMain.NotOnTop
i = True
End If
frmSelector.Show vbNormal, Me
If i = True Then mdiMain.OnTop
Else
If frmMain.mnuHelpOnTop.Checked = True Then
mdiMain.NotOnTop
i = True
End If
frmSelector.Show vbNormal, Me
'If i = True Then frmMain.OnTop                         'Fix when time comes
End If

End Sub

Public Function Printhex(hex As String)
txtResult.text = hex
End Function

Public Function PrintDec(hex As String)
On Error GoTo err
txtResult.text = CLng("&H" & hex)
Exit Function
err:
txtResult.text = "Error."
End Function

Private Sub Form_Load()
LoadFormStatus Me
End Sub

Private Sub Form_Unload(cancel As Integer)
SaveFormStatus Me
End Sub
